<style>
	:global(:root){
		--color0: #000;
		--color1: #CCC;
	}
	:global(*){
		padding: 0;
		margin: 0;
		font-family: consolas, monospace;
		font-size: 1em;
	}
	:global(html, body){
		height: 100%;
		display: flex;
		flex-flow: column;
		justify-content: space-around;
		background-color: var(--color0);
		color: var(--color1);
	}

	:global(input){
		box-sizing: border-box; /*fixes inputs being bigger than their parents*/
		text-align: center;
		padding: 0.5em;
		border-radius: 0.4em;
		border: none;
	}
	:global(input:focus){
		outline: none;
		box-shadow: 0 0 3px 2px var(--color1);
	}
	:global(input:invalid){box-shadow: 0 0 3px 2px var(--color0);}
	:global(button, .button){
		display: inline-block;
		padding: 0.5em 1.4em;
		margin: 0.2em;
		border: 1px solid var(--color1);
		background-color: var(--color0);
		font-weight: 900;
		text-transform: uppercase;
		text-decoration: none;
		color: var(--color1);
		font-family: consolas, monospace;
		font-size: 1em;
	}
	:global(button:hover, .button:hover){text-decoration: none;}
	:global(button:disabled, .button:disabled){text-decoration: line-through;}

	main{
		width: 100%;
		max-width: 100vh;
		margin: auto;
		display: flex;
		flex-flow: column nowrap;
		justify-content: space-evenly;
	}
	p, footer{
		padding: 0.4em;
		text-align: center;
	}
</style>
<script>
	import {fetch} from './util/network'
	import Info from './info.svelte'
	import Input from './input.svelte'

	let fetching = false
</script>
<main>
	<Input placeholder='url or id' on:value={({detail: search})=> fetching = fetch('/info', {
		method: 'POST',
		headers: {'Content-Type': 'application/json'},
		data: {search}
	})}/>
	{#if fetching}
		{#await fetching.then(async d=>{
			const data = await d.json()
			data.duration = Number.parseInt(data.seconds)
			return data
		}) then data}
			<Info {...data}/>
		{:catch error}
			<p>{error}</p>
		{/await}
	{/if}
</main>
<footer>
	{#await fetch('/version').then(d=>{
		if(d.status >= 400 && d.status < 600) throw new Error(d.status)
		else return d.text()
	})}
		...
	{:then version}
		{version}
	{:catch error}
		{error}
	{/await}
</footer>
